/*
   Copyright 2010 Alfredo Braunstein, Farbod Kayhan and Riccardo Zecchina

   This file is a part of GFRBP, a lossy compressor of random independent
   binary sources in GF(q).

   This is a free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this file; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef FORMULA_H
#define FORMULA_H


#include <vector>

void readformula (char const *);
void createseq (void);
void initialmemo(void);
void leaf_removal(void);
int gfdis_seq(std::vector<int> const & a, std::vector<int> const & b);
double gfdistortion(std::vector<int> const & a, std::vector<int> const & b);



typedef double real_t;

typedef std::vector<real_t> DMes;


struct clausestruct {
	std::vector<int> varlist;                   //List of variables that the clause is connected
	std::vector<int> position;                  //This shows that in which position of the clauselist of the associated variable this check appears.
	std::vector<int> weightlist;                //Weights over the edges of the factor graph
	int clausedeg() const { return varlist.size(); }
};

struct varstruct {
	varstruct(int Q) : marginal(Q, 1.), exfield(Q, 1.) {}
	int vardeg() const { return clauselist.size(); }
	std::vector<int> clauselist;                   //List of clauses the variable appears
	std::vector<DMes> messages;    //Messages in the ith iteration of the variable
	DMes marginal;                  //Marginal values
	DMes exfield;                   //External field on the variable
};


#endif
