/*
   Copyright 2010 Alfredo Braunstein, Farbod Kayhan and Riccardo Zecchina

   This file is a part of GFRBP, a lossy compressor of random independent
   binary sources in GF(q).

   This is a free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this file; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <time.h>
#include <stdlib.h>

#include "random.hpp"



//returns an integer random number uniformly in the interval [0,elsize)
int intrand(int elsize){

	double r,x;
	int rneed;
	r = ((double) rand() / ((double)(RAND_MAX) + (double)(1)));
	x = r * elsize;
	rneed = (int) x;

	return(rneed);
}

//returns a random real uniformly in [0,1)
double realrand (){

  double r;
  r = ((double) rand() / ((double)(RAND_MAX) + (double)(1)));
  return r;
}

